package com.sunup.amps.wfeutil;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.Configuration;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.HistoryService;
import org.jbpm.api.IdentityService;
import org.jbpm.api.ManagementService;
import org.jbpm.api.NewDeployment;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.RepositoryService;
import org.jbpm.api.TaskService;

public class WfeUtility
{ 
  private static Configuration configuration = null;
  private static ProcessEngine processEngine = null;
	  
  private static RepositoryService repositoryService;
  private static ExecutionService  executionService;
  private static ManagementService managementService;
  private static TaskService       taskService;
  private static HistoryService    historyService;
  private static IdentityService   identityService;
	  
  public WfeUtility() {}

  public static void main(String []args)
  {	  
	initJbpmEngine();  
	  
    int count = 0;
	while(count < args.length)
	{      
	  String val = args[count]; 
	  count++;
	      
	  if( val.equals("-deploy") )	     
	    deployProcessDefinition( args[count] );
	  else if( val.equals("-start") )
		startProcessInstance( args[count] );  
	  else if( val.equals("-signal") )
	    signalExecution( args[count] );  
	  else if( val.equals("-all") )
		deployAndRun( args[count] );	  
	}
	System.exit(0);    
  }
  
  private static synchronized void initJbpmEngine()
  {    
    if (processEngine != null)
      return;
    configuration = new Configuration();
   
    processEngine = configuration.buildProcessEngine();        
    repositoryService = processEngine.get(RepositoryService.class);
    executionService  = processEngine.getExecutionService();
    historyService    = processEngine.getHistoryService();
    managementService = processEngine.getManagementService();
    taskService       = processEngine.getTaskService();
    identityService   = processEngine.getIdentityService();       
  }
  
  private static void deployProcessDefinition(String fileName)
  { 	
    NewDeployment dplyA = repositoryService.createDeployment();
	NewDeployment dplyB = dplyA.addResourceFromClasspath( fileName );
	dplyB.deploy();
  }
  
  private static void startProcessInstance(String processName)
  {	  	  
    executionService.startProcessInstanceByKey( processName );
  }
  
  private static void signalExecution(String executionId)
  {	  
    executionService.signalExecutionById( executionId );	  
  }
  
  private static void deployAndRun(String processName)
  {	  
    ProcessInstance processInstance = 
    	executionService.startProcessInstanceByKey( processName );
  
	Execution wait = processInstance.findActiveExecutionIn("check_id");
    
    executionService.signalExecutionById( wait.getId() );       	  
  }
  
}
